.TH GETARGS 3L
.SH NAME
getargs - access command line arguments and environment strings
.SH SYNOPSIS
.nf
extern getargs();

getargs (pargc, pargv, penvc, penvv)
int *pargc, *penvc; char ***pargv, ***penvv;
.fi
.SH DESCRIPTION
getargs - finds argument and exported environment counts and
pointers.  User should declare argc, argv etc. as in main and
call getargs with the addresses of same.  This allows access to
arguments from subroutines without saving argc etc. in main.
For example:
.nf
	int argc, envc;
	char *argv[], *envv[];
	getargs(&argc, &argv, &envc, &envv);

.fi
will leave argc, argv, and envv looking just like the would have in main.
envc is an obvious addition.

.SH FILES
.nf
source on: /usr/src/local/date/getargs.c
in library: /usr/local/lib/libdate.a
.fi
.SH BUGS
