#ifndef STDTIME
#define STDTIME 1
typedef double TIME;

extern int fprintinc(), printinc();
extern TIME date(), stdtime(), ymdtime(), bartime(), atodate();
extern TIME timenow(), atoinc();
extern char *printt(), *fprintt(); 
extern char *sprintinc(), *getinc();
extern char *signif2(), *signif(), *signiffrac();
extern char *sindex(), *stindex(), *strlow(), *strup(), *mprefix();
extern double divint();
extern double atofreq();
extern double floor2(), ceil2();
extern double atocarr();
extern double angle_norm();
extern double ask();

typedef struct
	{TIME	_time;		/* standard time		*/
	 short	_year;		/* year as 1980			*/
	 short	_doy;		/* day of year: Jan 1 = 1	*/
	 short	_month;		/* month: Jan = 1		*/
	 short	_day;		/* day in month			*/
	 short	_hour;		/* hour in day: 0 to 23		*/
	 short	_minute;	/* minute in hour: 0 to 59	*/
	 short	_second;	/* second: 0 to 59		*/
	 short	_dow;		/* day of week: Monday = 1	*/
	 short	_dim;		/* days in current month	*/
	 short	_leap;		/* 1 if a leap year		*/
	 short	_spare1;	/* for later implimentation	*/
	 short	_spare2;	/* for later implimentation	*/
	 short	_brot;		/* Bartels rotation		*/
	 short	_bday;		/* day within rotation		*/
	 short	_Crot;		/* Carrington rotation		*/
	 short	_Clong;		/* Carrington longitude		*/
	 TIME	_Ctime;		/* Carrington time		*/
	 TIME	_SPARETIME;	/* What we all have so much of	*/
	} DATE;

extern DATE curtime;

static char * _Months[13] =
	{
	"BAD",
	"January",
	"February",
	"March",
	"April",
	"May",
	"June",
	"July",
	"August",
	"September",
	"October",
	"November",
	"December"
	} ;

static char * _MON[13] =
	{
	"BAD",
	"JAN",
	"FEB",
	"MAR",
	"APR",
	"MAY",
	"JUN",
	"JUL",
	"AUG",
	"SEP",
	"OCT",
	"NOV",
	"DEC"
	} ;
#endif
